<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class Fm00028003RelatorioTarefasAtrasadasFactory
{
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTarefasEmAtraso($operadores, $operador)
    {

        $sql = "SELECT CHKA.NRCHECKLISTAGEND, CHKA.NRLOCALCLIENTE, CHKA.NRCHECKLIST, CHKA.CDOPERADOR,
                    TO_CHAR(CHKA.DTHORAAGEND, 'DD/MM/YY HH24:MI') DTHORAAGEND, CHKA.IDATIVO, CHKA.NMCHECKLISTAGEND, 
                    FUNC.NMOPERADOR, LC.NMLOCALCLIENTE, CHK.NMCHECKLIST, LC.CDCLIENTE, C.NMRAZSOCCLIE,
                    ROUND(24 *(SYSDATE - CHKA.DTHORAAGEND), 2) AS TEMPO_ATRASO
                        FROM FCM_CHECKLISTAGEND CHKA
                    LEFT JOIN OPERADOR FUNC 
                        ON FUNC.CDOPERADOR = CHKA.CDOPERADOR
                    LEFT JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CHKA.NRLOCALCLIENTE
                    LEFT JOIN FCM_CHECKLIST CHK
                        ON CHK.NRCHECKLIST = CHKA.NRCHECKLIST
                    LEFT JOIN CLIENTE C
                        ON C.CDCLIENTE = LC.CDCLIENTE
                        WHERE ((CHKA.CDOPERADOR IN ($operadores))
                        OR (CHKA.CDOPERINCLUSAO = {$operador}))
                        AND  CHKA.IDSITUACAOAGEND = 1
                        AND CHKA.DTHORAAGEND < SYSDATE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getVistoriasEmAtraso($operadores, $operador)
    {

        $sql = "SELECT GCHK.NRGERENCIAMENTOCHK, GCHK.NRLOCALCLIENTE, GCHK.NRCHECKLIST, GCHK.CDOPERADOR,
                TO_CHAR(GCHK.DTHORAAGEND, 'DD/MM/YY HH24:MI') DTHORAAGEND, GCHK.IDATIVO, GCHK.NMGERENCIAMENTOCHK, 
                FUNC.NMOPERADOR, LC.NMLOCALCLIENTE, CHK.NMCHECKLIST, LC.CDCLIENTE, C.NMRAZSOCCLIE,
                ROUND(24 *(SYSDATE - GCHK.DTHORAAGEND), 2) AS TEMPO_ATRASO
                    FROM FCM_GERENCIAMENTOCHK GCHK
                LEFT JOIN OPERADOR FUNC 
                    ON FUNC.CDOPERADOR = GCHK.CDOPERADOR
                LEFT JOIN FCM_LOCALCLI LC
                    ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE
                LEFT JOIN FCM_CHECKLIST CHK
                    ON CHK.NRCHECKLIST = GCHK.NRCHECKLIST
                LEFT JOIN CLIENTE C
                    ON C.CDCLIENTE = LC.CDCLIENTE
                    WHERE ((GCHK.CDOPERADOR IN ($operadores))
                    OR (GCHK.CDOPERINCLUSAO = {$operador}))
                    AND  GCHK.IDSITUACAOGERCHK = 1
                    AND GCHK.DTHORAAGEND < SYSDATE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
