<?php

namespace FM\Service;

use FM\Factory\Fm00004001TransferirTarefasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\LogtransfAgendService;

class Fm00004001TransferirTarefasService
{

    protected $connection;
    protected $Fm00004001TransferirTarefasFactory;
    protected $Environment;
    protected $newCode;
    protected $LogtransfAgendService;

    public function __construct(EntityManager $entityManager, LogtransfAgendService $LogtransfAgendService, Fm00004001TransferirTarefasFactory $Fm00004001TransferirTarefasFactory, Environment $Environment, NewCode $newCode)
    {
        $this->connection = $entityManager->getConnection();
        $this->Fm00004001TransferirTarefasFactory = $Fm00004001TransferirTarefasFactory;
        $this->LogtransfAgendService = $LogtransfAgendService;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function listTask($param)
    {
        $params = "";
        $param1 = array(
            "startPeriod"    => $param['start'],
            "finishPeriod"   => $param['finish'],
            "CDOPERADOR"     => $this->Environment->getCdOperador()
        );

        return $this->Fm00004001TransferirTarefasFactory->listTask($param1, $params);
    }

    public function infoTask($param)
    {
        if ($param['tipo'] == 'T') {
            $parametros = array(
                "NRCHECKLISTAGEND" => $param['nr'],
                "CDOPERADOR" => $this->Environment->getCdOperador(),
            );

            return $this->Fm00004001TransferirTarefasFactory->infoTask($parametros);
        } else {
            $parametros = array(
                "NRGERENCIAMENTOCHK" => $param['nr'],
                "CDOPERADOR" => $this->Environment->getCdOperador(),
            );
            return $this->Fm00004001TransferirTarefasFactory->informacoesVistoria($parametros);
        }
    }

    public function tarefasOperador($parametros)
    {
        $filtro = '';
        $filtroGerChk = '';
    
        if (isset($parametros['CDCLIENTE'])) {
            $filtro = $filtro . " AND FCM_LOCALCLI.CDCLIENTE IN ( '" . $parametros['CDCLIENTE'] . "')";
            $filtroGerChk = $filtroGerChk . " AND FCM_LOCALCLI.CDCLIENTE IN ( '" . $parametros['CDCLIENTE'] . "')";
        }
    
        if (isset($parametros['DTHORAGEND'])) {
            $dataInicial = $parametros['DTHORAGEND'][0];
            $dataFinal = array_key_exists("1", $parametros['DTHORAGEND']) ? $parametros['DTHORAGEND'][1] : null;
            
            if ($dataFinal != null) {
                $filtro = $filtro . " AND FCM_CHECKLISTAGEND.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
                $filtroGerChk = $filtroGerChk . " AND FCM_GERENCIAMENTOCHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
            } else {
                $data = $dataInicial;
                $filtro = $filtro . " AND FCM_CHECKLISTAGEND.DTHORAAGEND = '" . $data ."'";
                $filtroGerChk = $filtroGerChk .  " AND FCM_GERENCIAMENTOCHK.DTHORAAGEND = '" . $data ."'";
            }
        }

        return $this->Fm00004001TransferirTarefasFactory->tarefasOperador(array(
            "CDOPERADOR" => $parametros['CDOPERADOR'],
        ), $filtro, $filtroGerChk);
    }

    public function transferTask($param)
    {
        $this->connection->beginTransaction();

        try {
            $nrchecklistagend = implode(',', $param['idTarefa']);
            $this->Fm00004001TransferirTarefasFactory->transferTask(array(
                "CDOPERADOR"   => $param['funcionarioDestino'],
                "CDOPERULTATU" => $this->Environment->getCdOperador(),
                "NRORGULTATU"  => $this->Environment->getNrOrg()
            ), $nrchecklistagend);

            foreach ($param['idTarefa'] as $id) {
                $dadosHistorico = $this->Fm00004001TransferirTarefasFactory->dadosTask($id);
                $dadosHistorico = $dadosHistorico[0];
                $dadosHistorico['funcionarioOrigem'] = $param['funcionarioOrigem'];
                $dadosHistorico['funcionarioDestino'] = $param['funcionarioDestino'];
                $dadosHistorico['operadorTransfer'] = $this->Environment->getCdOperador();
                $this->LogtransfAgendService->insertLogTrasnfer($dadosHistorico);
            }

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function getLocals($id)
    {

        $locals = $this->Fm00004001TransferirTarefasFactory->getLocals($id);
        return $locals;
    }

    public function listChecklistAgend($params)
    {
        $checklistAgends = $this->Fm00004001TransferirTarefasFactory->listChecklistAgend($params);
        return $checklistAgends;
    }

    public function innerJoinChecklist($params)
    {
        $checklistAgends = $this->Fm00004001TransferirTarefasFactory->checklistAgendsInnerJoinChecklist($params);
        return $checklistAgends;
    }

    public function updateChecklistAgend($params)
    {
        $updatedValues = $this->Fm00004001TransferirTarefasFactory->updateChecklistAgend($params);
        return $updatedValues;
    }

    public function setDTHRCHECLIST()
    {
        $operadores = $this->Fm00004001TransferirTarefasFactory->setDTHRCHECLIST();
        return $operadores;
    }
}
