/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FORMEMISNF                                               */
/* Tabela : FORMEMISNF                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FORMEMISNF' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FORMEMISNF
GO

CREATE TRIGGER DTULTATU_FORMEMISNF
ON FORMEMISNF
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FORMEMISNF', null, 'CDTIPEMNF='+  CDTIPEMNF + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FORMEMISNF
      SET DTULTATUFENF = GETDATE()
      FROM INSERTED;
   END;
END;
GO

