IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'UPDATE_ITEM_VENDA' AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID              AND
	        U.NAME = USER)

DROP PROCEDURE UPDATE_ITEM_VENDA
GO

CREATE PROCEDURE UPDATE_ITEM_VENDA
   (@P_CDFILIAL    VARCHAR(4),
    @P_CDLOJA      VARCHAR(10),
    @P_DTINICIAL   DATETIME,
    @P_DTFINAL     DATETIME,
    @P_CDCAIXA     VARCHAR(200),
    @P_LISTAVENDA  VARCHAR(200),
    @P_CDPRODUTO    VARCHAR(200),
    @P_CDFILIPROC  VARCHAR(4),
    @P_DSMENSAGEM  VARCHAR(200),
    @P_NRLANCTONF  VARCHAR(10),
    @P_CDCONTADOR  NUMERIC)

AS

   DECLARE @V_DSDADOADIC     VARCHAR(120);
   DECLARE @V_NRDADOADIC     VARCHAR(3);
   DECLARE @V_IDTIPORECE     VARCHAR(1);
   DECLARE @V_NRCUPOMFIS     VARCHAR(10);
   DECLARE @V_DSMENSCPFCUP   VARCHAR(50);
   DECLARE @V_DSMENSDADOADIC VARCHAR(120);
   DECLARE @V_DSMD5FORSALE   VARCHAR(50);
   DECLARE @V_NRDADOADICAUX  VARCHAR(03);

   DECLARE @V_CDCONTADOR   NUMERIC;

   /*VARIAVEIS DO CURSOR*/
   DECLARE @C_CDFILIAL     VARCHAR(4);
   DECLARE @C_NRSEQVENDA   VARCHAR(10);
   DECLARE @C_CDCAIXA      VARCHAR(3);
   DECLARE @C_CDLOJA       VARCHAR(10);
   DECLARE @C_DTENTRVENDA  DATETIME;
   DECLARE @C_CDPRODUTO    VARCHAR(10);
   DECLARE @C_NMPRODUTO    VARCHAR(50);
   DECLARE @C_CDARVPROD    VARCHAR(20);
   DECLARE @C_CDPRODESTO   VARCHAR(10);
   DECLARE @C_NRCUPOMFIS   VARCHAR(10);
   DECLARE @C_VRUNITVEND   FLOAT;
   DECLARE @C_QTPRODVEND   FLOAT;
   DECLARE @C_VRDESITVEND  FLOAT;
   DECLARE @C_VRTOTAITEM   FLOAT;
   DECLARE @C_DSMARCAECFVE VARCHAR(30);
   DECLARE @C_DSMODELOECFVE VARCHAR(30);
   DECLARE @C_NRSERIEIMPVND VARCHAR(50);

BEGIN

   SET @V_CDCONTADOR = 1;
   SET @V_DSDADOADIC = '';
   SET @V_NRCUPOMFIS = 'X';

   /*Atualizao de Cdigo MD5 na Tabela de Dados Adicionais*/
   SELECT @V_NRDADOADIC = ISNULL(MAX(NRDADOADIC), '0')
     FROM DADOSADIC
    WHERE CDFILIAL   = @P_CDFILIPROC
      AND NRLANCTONF = @P_NRLANCTONF;

   SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);

   SELECT @V_DSMD5FORSALE = DSMD5FORSALE
     FROM PARAVEND
    WHERE CDFILIAL = @P_CDFILIPROC;


   IF (@V_DSMD5FORSALE IS NOT NULL) BEGIN
      SELECT @V_NRDADOADICAUX = MAX(NRDADOADIC)
        FROM DADOSADIC
       WHERE CDFILIAL   = @P_CDFILIPROC
         AND NRLANCTONF = @P_NRLANCTONF
         AND CHARINDEX('Cdigo MD5', DSDADOADIC) > 1;

      IF (@V_NRDADOADICAUX IS NULL) BEGIN

         INSERT INTO DADOSADIC
         (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
         (@P_CDFILIPROC, @P_NRLANCTONF, @V_NRDADOADIC, SUBSTRING('Cdigo MD5: ' + @V_DSMD5FORSALE, 1, 120));
      END;
   END;

   /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
   SELECT @V_NRDADOADIC = ISNULL(MAX(NRDADOADIC), '0')
     FROM DADOSADIC
    WHERE CDFILIAL   = @P_CDFILIPROC
      AND NRLANCTONF = @P_NRLANCTONF;

   DECLARE C_ITEMVENDAMD5 CURSOR FOR
      SELECT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.CDLOJA,
             V.DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO, V.NRCUPOMFIS,
             (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             V.DSMARCAECFVE, V.DSMODELOECFVE, V.NRSERIEIMPVND
      FROM VENDA V, ITEMVENDA I, PRODUTO P
      WHERE (V.CDFILIAL     = @P_CDFILIAL)       AND
            (V.CDLOJA       = @P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.IDSITUVENDA  = 'O')              AND
            (I.CDPRODUTO    = P.CDPRODUTO)      AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN @P_DTINICIAL  AND @P_DTFINAL) AND
            ((CHARINDEX(V.CDCAIXA, @P_CDCAIXA) > 0)  OR (@P_CDCAIXA IS NULL)) AND
            ((@P_LISTAVENDA IS NULL) OR (CHARINDEX(V.CDFILIAL+V.CDCAIXA+V.NRSEQVENDA, @P_LISTAVENDA) > 0));
/*----------------------------------------------------------------------------------------*/
   OPEN C_ITEMVENDAMD5;

   FETCH NEXT FROM C_ITEMVENDAMD5 INTO @C_CDFILIAL, @C_NRSEQVENDA, @C_CDCAIXA, @C_CDLOJA, @C_DTENTRVENDA,
                                       @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD, @C_CDPRODESTO, @C_NRCUPOMFIS, @C_VRUNITVEND,
                                       @C_DSMARCAECFVE, @C_DSMODELOECFVE, @C_NRSERIEIMPVND;
   WHILE (@@FETCH_STATUS = 0) BEGIN


      /*Atualizao da Tabela ITEMVENDA*/
      UPDATE ITEMVENDA
      SET CDFILIALNF  = @P_CDFILIPROC,
          NRLANCTONF  = @P_NRLANCTONF,
          NRSEQITPROD = RIGHT(REPLICATE('0',4)+CONVERT(VARCHAR,@V_CDCONTADOR),4)
      WHERE (CDFILIAL     = @C_CDFILIAL)   AND
            (CDCAIXA      = @C_CDCAIXA)    AND
            (NRSEQVENDA   = @C_NRSEQVENDA) AND
            (CDPRODUTO    = @C_CDPRODUTO)  AND
            ((VRUNITVEND + ISNULL(VRUNITVENDCL,0)) = @C_VRUNITVEND);

      /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
      SELECT @V_NRDADOADICAUX = ISNULL(MAX(NRDADOADIC), '0')
        FROM DADOSADIC
       WHERE CDFILIAL   = @P_CDFILIPROC
         AND NRLANCTONF = @P_NRLANCTONF
         AND CHARINDEX('Marca:', DSDADOADIC) > 1;

      SELECT @V_DSDADOADIC = MAX(DSDADOADIC)
        FROM DADOSADIC
       WHERE CDFILIAL   = @P_CDFILIPROC
         AND NRLANCTONF = @P_NRLANCTONF
         AND NRDADOADIC = @V_NRDADOADICAUX;

      IF (CONVERT(INT, @V_NRDADOADICAUX) > 0) BEGIN
         SET @V_NRDADOADIC = @V_NRDADOADICAUX;
      END;

      SELECT @V_IDTIPORECE = MAX(T.IDTIPORECE)
      FROM MOVICLIE M, TIPORECE T
      WHERE M.CDFILIAL   = @C_CDFILIAL   AND
            M.CDCAIXA    = @C_CDCAIXA    AND
            M.NRSEQVENDA = @C_NRSEQVENDA AND
            M.CDTIPORECE = T.CDTIPORECE  AND
            T.IDTIPORECE <> '9';

      IF (@V_NRDADOADIC < '998') BEGIN
         IF (@V_NRCUPOMFIS <> @C_NRCUPOMFIS) BEGIN
            IF ((LEN(@V_DSDADOADIC + ', '+ @C_NRCUPOMFIS) >= 120) OR (@V_DSDADOADIC IS NULL)) AND
               (@C_NRCUPOMFIS IS NOT NULL) BEGIN

                  SET @V_DSDADOADIC = @P_DSMENSAGEM + @C_NRCUPOMFIS +
                                      ' (Marca: ' + SUBSTRING(@C_DSMARCAECFVE, 1, 15) +
                                      ', Mod: ' + SUBSTRING(@C_DSMODELOECFVE, 1, 15) +
                                      ', N: ' + @C_NRSERIEIMPVND +
                                      ')';

                  SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);

                  INSERT INTO DADOSADIC
                     (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                  VALUES
                     (@P_CDFILIPROC, @P_NRLANCTONF, @V_NRDADOADIC, SUBSTRING(@V_DSDADOADIC, 1, 120));


            END
            ELSE BEGIN

                  SET @V_DSDADOADIC = @V_DSDADOADIC + ', ' + @C_NRCUPOMFIS;

                  UPDATE DADOSADIC
                  SET DSDADOADIC = @V_DSDADOADIC
                  WHERE CDFILIAL   = @P_CDFILIPROC AND
                        NRLANCTONF = @P_NRLANCTONF AND
                        NRDADOADIC = @V_NRDADOADIC;

            END;

            SET @V_NRCUPOMFIS = ISNULL(@C_NRCUPOMFIS, 'X');

         END;
      END;
      FETCH NEXT FROM C_ITEMVENDAMD5 INTO @C_CDFILIAL, @C_NRSEQVENDA, @C_CDCAIXA, @C_CDLOJA, @C_DTENTRVENDA,
                                          @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD, @C_CDPRODESTO, @C_NRCUPOMFIS, @C_VRUNITVEND,
                                          @C_DSMARCAECFVE, @C_DSMODELOECFVE, @C_NRSERIEIMPVND;
   END;
   CLOSE C_ITEMVENDAMD5;
   DEALLOCATE C_ITEMVENDAMD5;

   SET @V_CDCONTADOR = 1;
   SET @V_DSDADOADIC = '';
   SET @V_NRCUPOMFIS = 'X';

   DECLARE C_ITEMDEVOLUCAOAUX CURSOR FOR
      SELECT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.CDLOJA,
             V.DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO, V.NRCUPOMFIS,
             (I.VRUNITVEND + ISNULL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             V.DSMARCAECFVE, V.DSMODELOECFVE, V.NRSERIEIMPVND
      FROM VENDA V, ITEMVENDA I, PRODUTO P
      WHERE (V.CDFILIAL     = @P_CDFILIAL)       AND
            (V.CDLOJA       = @P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.IDSITUVENDA  = 'D')              AND
            (I.CDPRODUTO    = P.CDPRODUTO)      AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN @P_DTINICIAL  AND @P_DTFINAL) AND
            ((CHARINDEX(V.CDCAIXA, @P_CDCAIXA) > 0)  OR (@P_CDCAIXA IS NULL)) AND
            ((@P_LISTAVENDA IS NULL) OR (CHARINDEX(V.CDFILIAL+V.CDCAIXA+V.NRSEQVENDA, @P_LISTAVENDA) > 0));

   OPEN C_ITEMDEVOLUCAOAUX;

   FETCH NEXT FROM C_ITEMDEVOLUCAOAUX INTO @C_CDFILIAL, @C_NRSEQVENDA, @C_CDCAIXA, @C_CDLOJA, @C_DTENTRVENDA,
                                           @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD, @C_CDPRODESTO, @C_NRCUPOMFIS, @C_VRUNITVEND,
                                           @C_DSMARCAECFVE, @C_DSMODELOECFVE, @C_NRSERIEIMPVND;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      /*Atualizao da Tabela ITEMVENDA*/
      UPDATE ITEMVENDA
      SET CDFILIALNF  = @P_CDFILIPROC,
          NRLANCTONF  = @P_NRLANCTONF,
          NRSEQITPROD = RIGHT(REPLICATE('0',4)+CONVERT(VARCHAR, @V_CDCONTADOR),4)
      WHERE (CDFILIAL     = @C_CDFILIAL)   AND
            (CDCAIXA      = @C_CDCAIXA)    AND
            (NRSEQVENDA   = @C_NRSEQVENDA) AND
            (CDPRODUTO    = @C_CDPRODUTO)  AND
            ((VRUNITVEND + ISNULL(VRUNITVENDCL,0)) = @C_VRUNITVEND);

      /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
      SELECT @V_NRDADOADICAUX = ISNULL(MAX(NRDADOADIC), '0')
        FROM DADOSADIC
       WHERE CDFILIAL   = @P_CDFILIPROC
         AND NRLANCTONF = @P_NRLANCTONF
         AND CHARINDEX('Marca:', DSDADOADIC) > 0;

      SELECT @V_DSDADOADIC = MAX(DSDADOADIC)
        FROM DADOSADIC
       WHERE CDFILIAL   = @P_CDFILIPROC
         AND NRLANCTONF = @P_NRLANCTONF
         AND NRDADOADIC = @V_NRDADOADICAUX;

      IF (CONVERT(INT, @V_NRDADOADICAUX) > 0) BEGIN
         SET @V_NRDADOADIC = @V_NRDADOADICAUX;
      END;

      SELECT @V_IDTIPORECE = MAX(T.IDTIPORECE)
      FROM MOVICLIE M, TIPORECE T
      WHERE M.CDFILIAL   = @C_CDFILIAL   AND
            M.CDCAIXA    = @C_CDCAIXA    AND
            M.NRSEQVENDA = @C_NRSEQVENDA AND
            M.CDTIPORECE = T.CDTIPORECE        AND
            T.IDTIPORECE <> '9';

      IF (@V_NRDADOADIC < '998') BEGIN
         IF @V_NRCUPOMFIS <> @C_NRCUPOMFIS BEGIN
            IF ((LEN(@V_DSDADOADIC + ', '+ @C_NRCUPOMFIS) >= 120) OR (@V_DSDADOADIC IS NULL)) AND
               (@C_NRCUPOMFIS IS NOT NULL) BEGIN
                  SET @V_DSDADOADIC = @P_DSMENSAGEM + @C_NRCUPOMFIS +
                                      ' (Marca: ' + SUBSTRING(@C_DSMARCAECFVE, 1, 15) +
                                      ', Mod: ' + SUBSTRING(@C_DSMODELOECFVE, 1, 15) +
                                      ', N: ' + @C_NRSERIEIMPVND +
                                      ')';

                  SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3)+CONVERT(VARCHAR, CONVERT(FLOAT, ISNULL(@V_NRDADOADIC, '0'))+1),3);
                  INSERT INTO DADOSADIC
                     (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                  VALUES
                     (@P_CDFILIPROC, @P_NRLANCTONF, @V_NRDADOADIC, SUBSTRING(@V_DSDADOADIC, 1, 120));

            END
            ELSE BEGIN

                  SET @V_DSDADOADIC = @V_DSDADOADIC + ', '+ @C_NRCUPOMFIS;

                  UPDATE DADOSADIC
                  SET DSDADOADIC = @V_DSDADOADIC
                  WHERE CDFILIAL   = @P_CDFILIPROC AND
                        NRLANCTONF = @P_NRLANCTONF AND
                        NRDADOADIC = @V_NRDADOADIC;
               END;

         END;
         SET @V_NRCUPOMFIS = ISNULL(@C_NRCUPOMFIS, 'X');
      END;
      FETCH NEXT FROM C_ITEMDEVOLUCAOAUX INTO @C_CDFILIAL, @C_NRSEQVENDA, @C_CDCAIXA, @C_CDLOJA, @C_DTENTRVENDA,
                                              @C_CDPRODUTO, @C_NMPRODUTO, @C_CDARVPROD, @C_CDPRODESTO, @C_NRCUPOMFIS, @C_VRUNITVEND,
                                              @C_DSMARCAECFVE, @C_DSMODELOECFVE, @C_NRSERIEIMPVND;
   END;
   CLOSE C_ITEMDEVOLUCAOAUX;
   DEALLOCATE C_ITEMDEVOLUCAOAUX;

   SELECT @V_DSMENSCPFCUP = MAX(C.DSMENSCPFCUP)
   FROM CAIXA C
   WHERE C.CDFILIAL = @P_CDFILIAL AND
         C.CDCAIXA = (SELECT MIN(CDCAIXA)
                      FROM CAIXA
                      WHERE CDFILIAL = @P_CDFILIAL AND
                            ((CHARINDEX(CDCAIXA, @P_CDCAIXA) > 0)  OR (@P_CDCAIXA IS NULL)) AND
                            DSMENSCPFCUP IS NOT NULL);

    SELECT @V_DSMENSDADOADIC = MAX(DSDADOADIC)
    FROM DADOSADIC
    WHERE CDFILIAL   = @P_CDFILIPROC AND
          NRLANCTONF = @P_NRLANCTONF AND
          DSDADOADIC = @V_DSMENSCPFCUP;

   IF (@V_DSMENSDADOADIC IS NULL) AND (@V_DSMENSCPFCUP IS NOT NULL) BEGIN

      SELECT @V_NRDADOADIC = ISNULL(MAX(NRDADOADIC), '0')
      FROM DADOSADIC
      WHERE CDFILIAL   = @P_CDFILIPROC AND
            NRLANCTONF = @P_NRLANCTONF;

      SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3)+CONVERT(VARCHAR, CONVERT(FLOAT, ISNULL(@V_NRDADOADIC, '0'))+1),3);

      IF (@V_NRDADOADIC < '998') BEGIN
         INSERT INTO DADOSADIC
            (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
            (@P_CDFILIPROC, @P_NRLANCTONF, @V_NRDADOADIC, SUBSTRING(@V_DSMENSCPFCUP, 1, 120));
      END;
   END;
END;
-- VERSAO --
EXEC ATUVEROBJ 'UPDATE_ITEM_VENDA','5.50.xxx';
GO

